#! /bin/bash
# $Id: pend_hook.bash,v 1.1 2004/09/15 06:00:05 mszick Exp $

:<<-'__pend_hook_Doc_'

    Copyright (c) Michael S. Zick, 2004
    License: Unrestricted reuse in any form, for any purpose.
    Warranty: None -{Its a script; the user is on their own.}-

Provides
    A function variable which may have its
    function reassigned dynamicly.

Style notes
    I try to use the form: ${some_name}
    for common variable references;

    and the form: $some_name
    for variables that hold commands or functions.

    But I slip up a lot. (msz)

__pend_hook_Doc_

# Put this variable in the command & function namespace.
declare -f _pend_hook_

# The do nothing function
pend_dummy() { : ; }

any_function() {
    echo 'The _pend_hook_ function does something now.'
}

# Assign the no-operation function to the hook
_pend_hook_='pend_dummy'

echo

# Lets see what that does
echo 'Before call to _pend_hook_'
$_pend_hook_
echo 'After call to _pend_hook_'

# Wow - that was interesting
echo

# Now enable the hook as something ?useful?
_pend_hook_='any_function'

# Then see what happens
echo 'Before enabled _pend_hook_'
$_pend_hook_
echo 'After enabled _pend_hook_'

echo

:<<-'_pend_hook_outputs_'

Before call to _pend_hook_
After call to _pend_hook_

Before enabled _pend_hook_
The _pend_hook_ function does something now.
After enabled _pend_hook_

_pend_hook_outputs_
exit 0